app.LaunchForm = Ext.extend(Ext.form.FormPanel, {

		title: ~'Форма запуску'~,
		region: 'center',
		frame: true,
		labelWidth: 130,
		monitorValid: true,
		
		loadClusterPartitions: function(a) {
		  this.storeClusterPartitions.loadData(a);
		},
		
		setProfile: function(profile) {
				var d = this.tfWorkDir.getValue();
				this.getForm().reset().setValues(profile);
				profile.make ? this.fieldsetMake.expand() : this.fieldsetMake.collapse();
				this.profile_author = profile.login;
				this.tfWorkDir.setValue((profile.work_dir && profile.login) ? profile.work_dir : d);
				this.updateInputs();
		},
		
		setWorkDir: function(dir) {
			 this.tfWorkDir.setValue(dir);
		},
		
		initComponent: function(){
		  var self = this;
				
				this.updateInputs = function(radio) {
						var rg = self.radiogroupRuntime, rgv = rg.getValue().getRawValue(), v = rgv != 'rsl', 
										c = self.comboClusterPartitions, s = c.getStore(), 
										i = s.find('partition', c.getValue()), lc; // local cluster
						
						if (i > -1)
						  lc = s.getAt(i).get('middleware') == '';
						else {
							 lc = !(rgv == 'custom' || rgv == 'rsl');
								c.setValue('');
						}
						
      if (radio && radio.getValue()) {
  						self.tfFileName.label.update(radio.tfLabel + ':');
				  } else {
								rg.items.get(0).setVisible(lc);
								rg.items.get(1).setVisible(lc);
								rg.items.get(2).setVisible(!lc);
								rg.items.get(3).setVisible(!lc);							
						}
						
						self.tfTaskParameters.setVisible(v);
						self.fieldsetResources.setVisible(v);
						self.tfTimeLimit.setDisabled(!v);
						self.tfCoresCount.setDisabled(!v);
						self.tfRuntimeEnv.setVisible(v && !lc);
						self.tfInputFiles.setVisible(v && !lc);
						self.tfOutputFiles.setVisible(v && !lc);
      self.fieldsetMake.setVisible(lc);
						self.fieldsetDependency.setVisible(lc);
						self.tfOtherParams.setVisible(v && !lc);
						
						if (lc && ['mpi', 'none'].indexOf(rgv) == -1)
								rg.setValue('mpi');
						if (!lc && ['custom', 'rsl'].indexOf(rgv) == -1)
								rg.setValue('custom');											  
				}
								
				this.comboDependencyTasks = new Ext.form.ComboBox({
						fieldLabel: ~'Задача'~,
						store: new Ext.data.JsonStore({
						  url: 'modules/_.php',
								method: 'POST',
								baseParams: {
								  cmd: 'tasks',
										short: 1
								},
								root: 'queues',
								fields: ['i', 'j']
						}),
						displayField: 'j',
						valueField: 'i',
						blankText: ~'Виберіть задачу'~,
						anchor: '100%',
						allowBlank: false,
						disabled: true,
						hiddenName: 'dependency_task',
						editable: false,
						triggerAction: 'all',
						mode: 'remote',
						listeners: {
								beforequery: function(qe){
										delete qe.combo.lastQuery;
								}
						}	
				});
				
				this.fieldsetDependency = new Ext.Container({
						layout: 'column',
						defaults: {
							 layout: 'form',
								columnWidth: .5,
								labelWidth: 130
						},
						items: [{
							 style: {padding: '0 10px 0 0'},														
						  items: {
										fieldLabel: ~'Умова залежності'~,
										xtype: 'combo',
										editable: false,
										store: [['', ~'немає залежності'~], ['afterok', ~'успішне завершення'~], ['afterfail', ~'завершення з помилкою'~]],
										value: '',
										triggerAction: 'all',
										anchor: '100%',
										hiddenName: 'dependency',
										listeners: {
												select: function(combo){
														self.comboDependencyTasks.setDisabled(combo.getValue() == '');
														if (combo.getValue() == '')
																self.comboDependencyTasks.clearInvalid();
												}
										}
								}								
						},{
						  items: this.comboDependencyTasks
						}]
				});	
				
				this.tfTaskName = new Ext.form.TextField({
						fieldLabel: ~'Ім\'я задачі'~,
						anchor: '100%',
						allowBlank: false,
						blankText: ~'Вкажіть назву задачі'~,
						name: 'task_name'
				});
									
				this.tfFileName = new Ext.form.TextField({
						fieldLabel: ~'Файл для виконання'~,
						anchor: '100%',
						name: 'file_name',
						allowBlank: false,
						blankText: ~'Вкажіть файл для виконання (файл скрипта)'~,
						listeners: {
							 afterrender: function(tf){
									 var t = new Ext.dd.DropTarget(this.getEl(), {
												ddGroup: 'gridFilesDD',
												notifyDrop: function(ddSource, e, data){
													 var r = ddSource.dragData.selections[0];
										    tf.setValue(r.data.name);										
													 return true;
												}
										});
								}
						}						
				});

    this.tfTaskParameters = new Ext.form.TextField({
						fieldLabel: ~'Параметри задачі'~,
						anchor: '100%',
						name: 'parameters',
						listeners: {
							 afterrender: function(tf){
									 var t = new Ext.dd.DropTarget(this.getEl(), {
												ddGroup: 'gridFilesDD',
												notifyDrop: function(ddSource, e, data){
													 var recs = ddSource.dragData.selections, s = tf.getValue(), v = [];
														if (s)
														  v.push(s);
														for (var i = 0; i < recs.length; i++)
														  v.push(recs[i].data.name);
										    tf.setValue(v.join(' '));	
														
													 return true;
												}
										});
									 
								}
						}
				});
		
				this.tfInputFiles = new Ext.form.TextField({
						fieldLabel: ~'Вхідні файли'~,
						anchor: '100%',
						name: 'input_files',
						hidden: true,
						listeners: {
							 afterrender: function(tf){
									 var t = new Ext.dd.DropTarget(this.getEl(), {
												ddGroup: 'gridFilesDD',
												notifyDrop: function(ddSource, e, data){
													 var recs = ddSource.dragData.selections, s = tf.getValue(), v = [];
														if (s)
														  v.push(s);
														for (var i = 0; i < recs.length; i++)
														  v.push('"' + recs[i].data.name + '"');
										    tf.setValue(v.join(' '));	
													 return true;
												}
										});
								}
						}
				});
				
				this.tfOutputFiles = new Ext.form.TextField({
						fieldLabel: ~'Вихідні файли'~,
						anchor: '100%',
						name: 'output_files',
						hidden: true,
						listeners: {
							 afterrender: function(tf){
									 var t = new Ext.dd.DropTarget(this.getEl(), {
												ddGroup: 'gridFilesDD',
												notifyDrop: function(ddSource, e, data){
													 var recs = ddSource.dragData.selections, s = tf.getValue(), v = [];
														if (s)
														  v.push(s);
														for (var i = 0; i < recs.length; i++)
														  v.push('"' + recs[i].data.name + '"');
										    tf.setValue(v.join(' '));	
													 return true;
												}
										});
								}
						}						
				});	
					
		  this.radiogroupRuntime = new Ext.form.RadioGroup({
						fieldLabel: ~'Скрипт запуску'~,
						columns: [.45, .45, .45, .45],			
						items: [{
								boxLabel: 'MPI', 
								name: 'runtime', 
								inputValue: 'mpi',
								tfLabel: ~'Файл для виконання'~,
								checked: true
						},{
								boxLabel: ~'Заданий користувачем'~,
								name: 'runtime', 
								tfLabel: ~'Файл скрипта'~,
								inputValue: 'none'
						},{
							 boxLabel: ~'Сформувати'~,
								name: 'runtime',
								tfLabel: ~'Файл для виконання'~,
								inputValue: 'custom',
								hidden: true
						},{
							 boxLabel: ~'Заданий користувачем (RSL)'~,
								name: 'runtime',
								tfLabel: ~'RSL файл'~,
								inputValue: 'rsl',
								hidden: true
						}],
						listeners: {
								change: function(group, radio) {	
								  self.updateInputs(radio);
								}
						}					
				});
				
				this.storeClusterPartitions = new Ext.data.ArrayStore({
						fields: ['partition', 'middleware']	  
				});
				
				this.comboClusterPartitions = new Ext.form.ComboBox({
						fieldLabel: ~'Кластер та черга'~,
						store: this.storeClusterPartitions,
						displayField: 'partition',
						anchor: '100%',
						allowBlank: false,
						blankText: ~'Оберіть розділ кластера'~,
						name: 'partition',
						mode: 'local',
						triggerAction: 'all',
						editable: false,
						listeners: {
								select: function(combo, record){
										self.updateInputs();
								}
						}
				});		
				
				this.comboProgLang = new Ext.form.ComboBox({
						fieldLabel: ~'Мова програмування'~,
						store: [['C', 'C'], ['C++', 'C++'], ['F77', 'F77'], ['F90', 'F90']],
						editable: false,
						triggerAction: 'all',
						allowBlank: false,
						blankText: ~'Виберіть мову програмування'~,
						name: 'language',
						anchor: '95%'
				});
				
				this.comboCompiler = new Ext.form.ComboBox({
						fieldLabel: ~'Компілятор'~,
						store: [['Intel', 'Intel'], ['GNU', 'GNU']],
						editable: false,
						triggerAction: 'all',
						allowBlank: false,
						blankText: ~'Виберіть компілятор'~,
						name: 'compiler',
						anchor: '100%'
				});		
				
				this.tfTimeLimit = new Ext.form.NumberField({
						fieldLabel: ~'Ліміт часу, хв'~,
						allowBlank: false,
						blankText: ~'Вкажіть ліміт часу на виконання задачі'~,
						minValue: 1,
						allowNegative: false,
						name: 'time_limit',
						anchor: '100%'
				});
				
				this.tfCoresCount = new Ext.form.NumberField({
						fieldLabel: ~'Кількість ядер'~,
						allowBlank: false,
						blankText: ~'Вкажіть кількість процесорних ядер'~,
						minValue: 1,
						allowNegative: false,
						name: 'processors',
						width: 40
				});
				
				this.tfCoresPerNode = new Ext.form.NumberField({
						minValue: 1,
						allowNegative: false,
						name: 'cores_per_node',
						width: 30
				})
				
				this.cfCoresCount = new Ext.form.CompositeField({
      anchor: '-20',
      msgTarget: 'side',				  
						items: [this.tfCoresCount, {
						  xtype: 'displayfield',
								value: '/'
						}, this.tfCoresPerNode, {
								xtype: 'displayfield',
								value: ~'на вузол'~
						}]
				})
				
				this.fieldsetResources = new Ext.Container({
						layout: 'column',
						anchor: '100%',
						defaults: {
							 layout: 'form',
								columnWidth: .5,
								labelWidth: 130
						},
						items: [{
								items: this.tfTimeLimit,
								style: {padding: '0 10px 0 0'}
						},{							 
								items: this.cfCoresCount
						}]
				});
				
				this.fieldsetMake = new Ext.form.FieldSet({
						layout: 'column',
						defaults: {
								layout: 'form',
								columnWidth: .5
						},
						title: ~'Компіляція'~,
						collapsed: true,
						checkboxToggle: true,
						checkboxName: 'make',
						items: [{
								labelWidth: 140,
								items: this.comboProgLang
						},{
								labelWidth: 100,
								items: this.comboCompiler
						}],
						listeners: {
								collapse: function(p) {
										self.comboProgLang.disable();
										self.comboCompiler.disable();										
								},
								expand: function(p) {		
										self.comboProgLang.enable();
										self.comboCompiler.enable();										
								}
						}
				});		
				
				this.tfRuntimeEnv = new Ext.form.TextField({
						hidden: true,
				  fieldLabel: ~'Середовище виконання'~,
						name: 'runtime_env',
						anchor: '100%'
				});
				
				this.tfWorkDir = new Ext.form.TextField({
						flex: 1,
						name: 'work_dir',
						submitValue: false,
						allowBlank: false,
						blankText: ~'Введіть робочу теку задачі'~
				});
				
				this.btnDirToProfile = new Ext.Button({
			   enableToggle: true,
						tooltip: ~'Зберігати робочу теку при збереженні профілю'~,
						iconCls: 'x-save-profile'
				});
				
				this.tfProfileDescr = new Ext.form.TextField({
						name: 'description',
						submitValue: false,
						fieldLabel: ~'Опис профілю'~,
						anchor: '100%'
				});
				
				this.tfOtherParams = new Ext.form.TextField({
						name: 'other_params',
						fieldLabel: ~'Інші параметри'~,
						anchor: '100%',
						hidden: true
				});
				
		  var config = {
					 profile_author: false,
						items: [{
								xtype: 'container',
								layout: 'column',
								defaults: {
								  xtype: 'container',
										layout: 'form',
										columnWidth: 0.5
								},
								items: [{
										style: {padding: '0 10px 0 0'},
										items: this.comboClusterPartitions
								}, {
									 items: this.tfTaskName
								}] 
						}, {
								xtype: 'compositefield',
								preventMark: true,
								fieldLabel: ~'Робоча тека'~,
								items: [this.tfWorkDir, {
										xtype: 'button',
										iconCls: 'x-action-goto',
										tooltip: ~'Перейти в цю теку'~,
										listeners: {
												click: function() {
														var f = self.tfWorkDir.getValue();
														if (f > '')
																self.fm.refresh({dir: f});
												}
										}
								}, this.btnDirToProfile],
						}, this.radiogroupRuntime, this.tfFileName, this.tfTaskParameters, 
						this.tfRuntimeEnv, 
						this.tfInputFiles, this.tfOutputFiles, this.fieldsetMake, this.fieldsetResources, this.fieldsetDependency, this.tfOtherParams, this.tfProfileDescr],
						buttons: [{
								text: ~'Очистити'~,
								handler: function() {
										self.getForm().reset();
										self.fieldsetMake.collapse();
								}
						},{
								text: ~'Зберегти'~,
								handler: function() {
									 if (self.tfTaskName.getValue() == '') {
										  Ext.Msg.show({
														icon: Ext.Msg.ERROR,
														title: ~'Помилка'~, 
														msg: ~'Вкажіть ім\'я задачі для збереження профілю'~,
														buttons: Ext.Msg.OK
												});
											 return;
										}
										var profile = self.getForm().getValues();
										if (self.btnDirToProfile.pressed)
 										 profile.work_dir = self.tfWorkDir.getValue();
										profile.description = self.tfProfileDescr.getValue();
										for (var i in profile)
										  if (profile[i] == '')
												  delete profile[i];
										profile.login = self.profile_author;
										self.fm.profilesPanel.saveProfile(profile);
								}
						},{
								text: ~'Запуск'~,
								formBind: true,
								handler: function() {
										var i = self.storeClusterPartitions.find('partition', self.comboClusterPartitions.getValue()), 
										    m = self.storeClusterPartitions.getAt(i).data.middleware,
														f = self.getForm().getValues();
										for (i in f)
										  if (f[i] == '')
												  delete f[i];
										f.work_dir = self.tfWorkDir.getValue();
										f.cmd = (m > '' ? 'grid_' : '') + 'launch';
										
										Ext.Ajax.request({
												url: 'modules/_.php',
												params: f,
												timeout: 120000,
												success: function(response, opts){
														var o = Ext.decode(response.responseText);
														var r = (new Date()).format('d.m.Y H:i:s') + ': ';
														if (Ext.isDefined(o.launch))
														  r += opts.params.task_name + ' ' + o.launch.out;
														if (Ext.isDefined(o.grid_launch))
														  r += opts.params.task_name + ' ' + (o.grid_launch.id || '') + (o.grid_launch.error || '');

														var p = self.fm.panelLog;
														p.update({r: r});
														var d = p.body.dom;
														d.scrollTop = d.scrollHeight - d.offsetHeight;
														if (p.collapsed)
														  Ext.get(self.fm.panelLog.getId() + '-xcollapsed').highlight('', {duration: 2});

														self.fm.refresh();
												}
										});
								}
						}]				
				};
								
		  Ext.applyIf(this, config);

    app.LaunchForm.superclass.initComponent.call(this);

		}
});