Ext.ns('app');

Ext.state.Manager.setProvider(new Ext.state.CookieProvider());

app.Interface = Ext.extend(Ext.Container, {
		
		checkGridSettings: function(g){
			 this.userSettings.gridEnabled = false;
				
				// check certificate
				if (Ext.isObject(g)) {
				  var c = ~'Сертифікат гріда недійсний або відсутній'~,
						    f = new Date(g.valid_from*1000), t = new Date(g.valid_to*1000), now = new Date();
						if (g.valid_from > 0 && g.valid_to > 0) {
						  this.userSettings.gridCertOK = g.valid_to*1000 > now.getTime();
								c = String.format(~'Видавець: {0}\\nВласник: {1}\\nДійсний з: {2}\\nДійсний до: {3}'~, 
								                  g.issuer, g.person, f.format('d.m.Y H:i:s'), t.format('d.m.Y H:i:s'));
						}
						this.userSettings.gridKeyOK = g.key == 1;
		  		this.settingsPanel.fillSettings({certificate: c, key: g.key});
				}
				
				switch (this.userSettings.grid_auth_mode) {
					 case 'cert':
						  with (this.userSettings)
						    gridEnabled = (gridCertOK && gridKeyOK);
						break;
						
						case 'myproxy':
						  with (this.userSettings)
  						  gridEnabled = (gridCertOK && myproxy_server && myproxy_login);
						break;
				}
				
				this.btnEnterGrid.setVisible(this.userSettings.gridEnabled && !this.userSettings.gridConnected);						
				this.btnLeaveGrid.setVisible(this.userSettings.gridConnected);	
				this.comboVO.setVisible(this.userSettings.gridEnabled && !this.userSettings.gridConnected);
		},
		
		checkStatus: function (response, opts) {
				var o = Ext.decode(response.responseText) || {}, s, grid = '';
				this.userSettings.gridConnected = false;
				if (Ext.isObject(o.grid_proxy_info)) {
						this.userSettings.gridConnected = o.grid_proxy_info.timeleft > 0;
						for (var i in o.grid_proxy_info)
						  grid += i + ': ' + o.grid_proxy_info[i] + '<br>';
				}
				
				this.btnEnterGrid.setVisible(this.userSettings.gridEnabled && !this.userSettings.gridConnected);
				this.btnLeaveGrid.setVisible(this.userSettings.gridConnected);
				this.comboVO.setVisible(!this.userSettings.gridConnected);
				
				s = '<span ext:qtip="' + grid + '">' +
				    ~'Ім\'я користувача'~ + ': <span style="font-weight:bold">' + this.userSettings.work_login + '</span>. ' + 
								((this.userSettings.grid_auth_mode == 'cert' && !this.userSettings.gridCertOK) ? ~'Сертифікат гріда недійсний. '~ : '') +
								(this.userSettings.gridEnabled ? ~'Грід'~ + 
								  (this.userSettings.gridConnected ? ' <span style="color:green">online</span>' : ' <span style="color:red">offline</span>') : '') + '</span>';
				this.tbStatus.setText(s);
				
				this.resourcesPanel.loadResources(this.userSettings.gridConnected);	
		},				

		initComponent: function() {
			 var self = this;
								
				this.taskStatus = {
						run: function(){
								Ext.Ajax.request({
										params: {
												cmd: 'status'
										},
										scope: this,
										success: this.checkStatus
								});
						},
						interval: 60000,
						scope: this
				}
				
				this.userSettings = {
					 gridCertOK: false, 
				  gridEnabled: false, 
						gridConnected: false, 
						grid_auth_mode: '',
						cert_auto: false,
						myproxy_server: '',
						myproxy_login: '',
						myproxy_auto: false
				};	
				
				this.storeVO = new Ext.data.JsonStore({
				  fields: [{name: 'default', type: 'boolean'}, 'name', 'server', 'port', 'dn', 'alias']
    })
				
				this.comboVO = new Ext.form.ComboBox({
				  store: this.storeVO,
						valueField: 'alias',
						displayField: 'alias',
						mode: 'local',
						triggerAction: 'all',
						emptyText: ~'Без ВО'~,
						typeAhead: true,
						valueNotFoundText: '',
						width: 100,
						hidden: true
    })
				
				this.btnEnterGrid = new Ext.Button({
						text: ~'Увійти в грід'~,
						hidden: true,
						handler: function(){
								if (!self.userSettings[self.userSettings.grid_auth_mode + '_auto']) {
									 Ext.Msg.getDialog().body.child('input').dom.type = 'password';
										Ext.Msg.show({
												title: ~'Вхід в грід'~, 
												msg: String.format(~'Введіть пароль гріда'~, self.fmCurrentDir), 
												icon: Ext.MessageBox.QUESTION,
												prompt: true,
												password: true,
												buttons: {ok: true, cancel: true},
												fn: function (btn, text, opt) {
														if (btn == 'ok' && text > '') {
																Ext.Ajax.request({
																		params: {
																				cmd: 'grid_proxy_init',
																				grid_password: text,
																			 vo: self.comboVO.getValue()
																		},
																		scope: self,
																		success: self.checkStatus
																});
														}
												}												  
										});
						} else 
								Ext.Ajax.request({
										params: {
												cmd: 'grid_proxy_init'
										},
										scope: self,
										success: self.checkStatus
								});
						}
				});
				
				this.btnLeaveGrid = new Ext.Button({
						text: ~'Вийти з грід'~,
						hidden: true,
						handler: function(){
								Ext.Ajax.request({
										params: {
												cmd: 'grid_proxy_destroy'
										},
										scope: self,
										success: self.checkStatus
								});	
						}																																				
				});		
				
				this.tbStatus = new Ext.Toolbar.TextItem();
				
				this.interfaceTb = new Ext.Toolbar({
						region: 'north',
						height: 27,
						items: [{
								xtype: 'tbtext',
								text: '<a href="http://scms.pro/" target="_blank">SCMS.pro</a>'
						}, this.tbStatus, this.comboVO, this.btnEnterGrid, this.btnLeaveGrid, {
								xtype: 'tbfill'	
						}, {
								text: ~'Вихід'~,
								handler: function(){
										window.location = '?action=log_out';
								}
						}]
				});

    this.storeClusters = new Ext.data.JsonStore({
						method: 'POST',
						url: 'modules/_.php',
						baseParams: {
								cmd: 'clusters'
						},
						root: 'clusters',
						fields: ['geo_lat', 'geo_lng', 'hostname', 'marker', 'country', 'city', 'location', 'address', 'organization', {
								name: 'avail', 
								defaultValue: 'unknown'
						}]
				});	
				
				this.fm = new app.FileManager({
						interface: this
				});
		
				this.settingsPanel = new app.SettingsPanel({
						interface: this
				});
				
				this.tasksPanel = new app.TasksPanel({
						interface: this
				});
				
				this.resourcesPanel = new app.ResourcesPanel({
						listeners: {
								partitionschange: function(a) {
										self.fm.loadClusterPartitions(a);
								}
						}
				});
				
				this.loadSettings = function(work_login, onSuccess) {
					 var params = {cmd: 'init'};
						if (work_login > '')
						  params.work_login = work_login;
					 Ext.Ajax.request({
						  params: params,
								success: function (response, opts) {
										var o = Ext.decode(response.responseText) || {};
										Ext.apply(self.userSettings, o.user_settings);
										
										self.settingsPanel.enable();
										self.settingsPanel.fillSettings(self.userSettings);
										self.settingsPanel.fillSettings({list_users: o.list_users});
										self.settingsPanel.fillSettings({remote_clusters: o.remote_clusters});
										self.settingsPanel.loadVO(o.grid_vo_list);
										self.comboVO.setValue(o.user_settings.default_vo_alias);

										self.fm.setHome(o.home);

          self.fm.loadProfiles(o.profiles);
										
										self.checkGridSettings(o.grid_cert_diag);
										
										self.resourcesPanel.loadResources();	
										self.tasksPanel.loadTasks();	
  								Ext.TaskMgr.start(self.taskStatus);
									 
										if (Ext.isFunction(onSuccess))
										  onSuccess()
								}
						})
				}
				
				this.interfaceTabs = new Ext.TabPanel({
						region: 'center',
						activeTab: 0,
						stateful: true,
						stateId: 'interfaceTabs',
						stateEvents:['tabchange'],
						getState: function() {
        return {
          activeTab:this.items.indexOf(this.getActiveTab())
        };
      },
						items: [this.fm, this.resourcesPanel,	this.tasksPanel, {
								title: ~'Мапа гріда'~,
								xtype: 'gridmap',
								iconCls: 'x-tab-map',
								setCenter: {
										lat: 58.481872, lng: 18.464806
								},
								interface: this
						}, this.settingsPanel]
				});
				
				var config = {
				  items: [this.interfaceTb, this.interfaceTabs],	
				};

    Ext.applyIf(this, config);

    app.Interface.superclass.initComponent.call(this);

		},
		
		afterRender: function(){
	  	app.Interface.superclass.afterRender.apply(this, arguments);
    
				var self = this;
				
				this.loadSettings('');
				
 			var e = Ext.get('loading');
    if (e)
				  e.remove();

		}
		
})

Ext.onReady(function () {
		Ext.Ajax.url = 'modules/_.php';
		Ext.Ajax.method = 'post';
  	
		Ext.QuickTips.init();
		  							
		var interface = new app.Interface({
				renderTo: 'div-interface',
				height: 900,
				layout: 'border',
				monitorResize: true
		});		
});