app.SettingsPanel = Ext.extend(Ext.Container, {
		title: ~'Налаштування'~,
		iconCls: 'x-tab-settings',
		disabled: true,
		
		fillSettings: function(o) {
				if (Ext.isDefined(o.certificate)) {
				  this.taGridCertInfo.setValue(o.certificate);
						this.labelCertKey.setValue(o.key ? ~'Встановлено'~ : ~'Відсутній'~);
				} else if (Ext.isObject(o.list_users)) {
  				var o = o.list_users;
						o.li = o.l + ' (' + o.i + ')';
						this.formPersonalSettings.getForm().setValues(o);
				} else if (Ext.isArray(o.remote_clusters)) {
					 this.gridRC.getStore().loadData(o.remote_clusters);
				}	else if (Ext.isObject(o)) {
				  this.formInterfaceSettings.getForm().setValues(o);
				  this.formGridAuth.getForm().setValues(o);
						this.interface.comboVO.setValue(o.default_vo_alias);
						this.tfCertPass.disable();
						this.tfCertPassConfirm.disable();
						this.tfMPPass.disable();
						this.tfMPPassConfirm.disable();
				}
		},

  loadVO: function(vo, default_vo) {
			 vo = vo || [];
				this.interface.userSettings.default_vo_alias = default_vo;
			 // set default vo
			 for (var i = 0; i < vo.length; i++)
				  vo[i]['default'] = default_vo == vo[i].alias;
			 this.interface.storeVO.loadData(vo);
		},
				
		initComponent: function(){
			 var self = this;
				
				this.comboLanguages = new Ext.ux.IconCombo({
						width: 200,
						fieldLabel: ~'Мова інтерфейсу'~,
						store: new Ext.data.ArrayStore({
								fields: ['id', 'n', 'cls'],
								data: languages
						}),
						displayField: 'n',
						valueField: 'id',
						iconClsField: 'cls',
						mode: 'local',
						forceSelection: true,
						allowBlank: false,
						editable: false,
						triggerAction: 'all',
						name: 'language_id',
						value: language_id,
						listeners: {
								select: function(){
										window.location = '/?language_id=' + this.getValue();
								}
						}				
				});
								
				this.formInterfaceSettings = new Ext.form.FormPanel({
      title: ~'Налаштування інтерфейсу'~,																																																								
						items: [this.comboLanguages]
				});
								
				this.tfUserPass = new Ext.form.TextField({
						disabled: true,
						fieldLabel: ~"Пароль"~,
						inputType: 'password',
						name: 'ow',
						allowBlank: false,
						blankText: ~'Введіть поточний пароль'~
				});

				this.tfUserPassNew = new Ext.form.TextField({
						disabled: true,
						fieldLabel: ~"Новий пароль"~,
						inputType: 'password',
						name: 'w',
						allowBlank: false,
						blankText: ~'Введіть новий пароль'~,
						vtype: 'pwdstr',
						enableKeyEvents: true,
						listeners: {
								keyup: function(){
										var pm = new PasswordMeter();
										pm.checkPassword(this.getValue());
										self.pbPass.updateProgress(pm.Score.adjusted/100, Math.floor(pm.Score.adjusted) + '/100', true);
								}
						}						
				});

				this.tfUserPassConfirm = new Ext.form.TextField({
						disabled: true,
						fieldLabel: ~"Підтвердження паролю"~,
						inputType: 'password',
						allowBlank: false,
						blankText: ~'Підтвердіть новий пароль'~,
						vtype: 'password',
						initialPassField: this.tfUserPassNew,
						submitValue: false
				});
				
				this.pbPass = new Ext.ProgressBar({
				  fieldLabel: ~'Складність паролю'~,
						disabled: true
				});
			 
				this.formPersonalSettings = new Ext.form.FormPanel({
						baseParams: {
								cmd: 'user_mod',
								type: 'personal'
						},						
						monitorValid: true,
						title: ~'Персональні дані'~,
						layout: 'column',
						defaults: {
								columnWidth: 0.5,
								labelWidth: 150,
								layout: 'form',
								xtype: 'container'
						},
						items: [{
								defaults: {
										xtype: 'textfield',
										anchor: '95%'
								},
								items: [{
										fieldLabel: ~"Ім'я користувача (ID)"~,
										readOnly: true,
										submitValue: false,
										name: 'li'
								},{
										fieldLabel: ~"Ім'я"~,
										name: 'n'
								},{
										fieldLabel: ~'Організація'~,
										name: 'o',
										readOnly: true,
										submitValue: false
								},{
										fieldLabel: ~"Адреса"~,
										name: 'a'
								},{
										fieldLabel: "E-mail",
										name: 'e',
										vtype: 'email',
										allowBlank: false,
										blankText: ~'Введіть E-mail'~
								},{
										fieldLabel: ~"Телефон"~,
										allowBlank: false,
										blankText: ~'Введіть телефон'~,
										name: 'p'
								},{
										fieldLabel: ~"Категорія"~,
										name: 'b'
								},{
										fieldLabel: ~"Опис"~,
										xtype: 'textarea',
										name: 'd'												
								}]
						},{
								defaults: {
										anchor: '100%'
								},
								items: [{
										fieldLabel: ~'Змінити пароль'~,
										xtype: 'checkbox',
										submitValue: false,
										handler: function(cb, v) {
												self.tfUserPass.setDisabled(!v);
												self.tfUserPassNew.setDisabled(!v);
												self.tfUserPassConfirm.setDisabled(!v);
												self.pbPass.setDisabled(!v);
										}
								}, this.tfUserPass, this.tfUserPassNew, this.tfUserPassConfirm, this.pbPass]
						}],
						buttons: [{
								text: ~'Зберегти'~,
								formBind: true,
								handler: function(){									  
								  self.formPersonalSettings.getForm().submit({
												success: function(form, action) {
													 if (action.result.success)
														  form.setValues(action.result.list_users[0]);
												}										
										});
								}
						}]	
				});
				
				this.tfCertPass = new Ext.form.TextField({
						fieldLabel: ~"Пароль"~,
						name: 'cert_pass',
						inputType: 'password',
						disabled: true,
						allowBlank: false
				});
				
				this.tfCertPassConfirm = new Ext.form.TextField({
						fieldLabel: ~"Підтвердження паролю"~,
						name: 'cert_passc',
						inputType: 'password',
						disabled: true,
						vtype: 'password',
						initialPassField: this.tfCertPass,
						allowBlank: false
				});
				
				this.taGridCertInfo = new Ext.form.TextArea({
						fieldLabel: ~'Інформація про сертифікат'~,
						readOnly: true,
						height: 150,
						submitValue: false
				});
				
				// radio listeners
				var rbl = {
					 check: function(f) {
  					 var mode = self.formGridAuth.getForm().getValues()['grid_auth_mode'];
		  				self.tfMPServer.setDisabled(mode != 'myproxy');
				  		self.tfMPLogin.setDisabled(mode != 'myproxy');
				  },
						afterrender: function(){
							 self.fillSettings(self.interface.userSettings);
						}
				};
				
				this.formCert = new Ext.form.FormPanel({
						title: ~'Грід-сертифікат'~,
						baseParams: {
							 cmd: 'save_settings_grid_cert'
						},
						fileUpload: true,
						defaults: {
							 anchor: '100%'
						},
						items: [{
								xtype: 'fileuploadfield',
								fieldLabel: ~'Файл сертифіката'~,
								name: 'cert_file'
						}, this.taGridCertInfo],
						buttons: [{
						  text: ~'Зберегти'~,
								handler: function(){
								  self.formCert.getForm().submit({
										  success: function(form, action) {
													 var o = action.result || {};
														self.interface.checkGridSettings(o.grid_cert_install);
												}
										})
								}
						}]
    });
				
				this.labelCertKey = new Ext.form.DisplayField({
      fieldLabel: ~'Інформація про ключ'~
				});
				
				this.fsCertKey = new Ext.form.FieldSet({
						title: ~'Грід-ключ'~,			
						layout: 'column',
						defaults: {
							 layout: 'form',
								xtype: 'container',
								columnWidth: .5,
								defaults: {
									 anchor: '100%'
								}
						},
						items: [{
								columnWidth: 1,
						  items: [{
										xtype: 'radio',
										name: 'grid_auth_mode',	
										inputValue: 'cert',
										fieldLabel: ~'Використовувати для авторизації'~,
										listeners: rbl	
								}]
						},{
							 style: {padding: '0 10px 0 0'},							
							 items: [this.labelCertKey, {
										xtype: 'fileuploadfield',
										fieldLabel: ~'Файл ключа'~,
										name: 'key_file'
								}]							
						},{
							 items: [{		
										xtype: 'checkbox',
										fieldLabel: ~'Автоматичний вхід'~,
										name: 'cert_auto',
										inputValue: 1,
										listeners: {
												check: function(cb, checked){
														self.tfCertPass.setDisabled(!checked);
														self.tfCertPassConfirm.setDisabled(!checked);
												}								
										}
								}, this.tfCertPass, this.tfCertPassConfirm]
						}]
    })
				
				this.tfMPServer = new Ext.form.TextField({
						fieldLabel: ~'Сервер'~,
						name: 'myproxy_server',
						allowBlank: false
    });
				
				this.tfMPLogin = new Ext.form.TextField({
				  fieldLabel: ~'Ім\'я користувача'~,
						name: 'myproxy_login',
						allowBlank: false
				});
				
				this.tfMPPass = new Ext.form.TextField({
						fieldLabel: ~"Пароль"~,
						name: 'myproxy_pass',
						inputType: 'password',
						disabled: true,
						allowBlank: false
				});

    this.tfMPPassConfirm = new Ext.form.TextField({
						fieldLabel: ~"Підтвердження паролю"~,
						name: 'myproxy_passc',
						inputType: 'password',
						disabled: true,
						vtype: 'password',
						initialPassField: this.tfMPPass,
						allowBlank: false
				});
						
				this.fsMyProxy = new Ext.form.FieldSet({
						title: ~'MyProxy'~,
						layout: 'column',
						defaults: {
							 layout: 'form',
								xtype: 'container',
								columnWidth: .5,
								defaults: {
									 anchor: '100%'
								}								
						},
						items: [{
								columnWidth: 1,
								items: [{
										xtype: 'radio',
										name: 'grid_auth_mode',
										inputValue: 'myproxy',
										fieldLabel: ~'Використовувати для авторизації'~,
										listeners: rbl
								}]
						},{
							 style: {padding: '0 10px 0 0'},
							 items: [this.tfMPServer, this.tfMPLogin]
						},{
							 items: [{
										xtype: 'checkbox',
										fieldLabel: ~'Автоматичний вхід'~,
										name: 'myproxy_auto',
										inputValue: 1,
										listeners: {
												check: function(cb, checked){
														self.tfMPPass.setDisabled(!checked);
														self.tfMPPassConfirm.setDisabled(!checked);
												}
										}								
								}, this.tfMPPass, this.tfMPPassConfirm]
						}]
    })
				
				this.formGridAuth = new Ext.form.FormPanel({
						title: ~'Авторизація у гріді'~,
						baseParams: {
							 cmd: 'save_settings_grid_auth'
						},
						monitorValid: true,
						fileUpload: true,
						items: [this.fsCertKey, this.fsMyProxy],
						buttons: [{
						  text: ~'Зберегти'~,
								formBind: true,
								handler: function(){
									 self.formGridAuth.getForm().submit({
										  success: function(form, action) {
													 var o = action.result || {};
														self.interface.checkGridSettings(o.grid_cert_install);
														self.interface.userSettings.grid_auth_mode = form.getValues().grid_auth_mode;
												}
										})
								}
						}]						
				})
				
				this.colDefault = new app.RadioColumn({
				  header: ~'Основна'~,
						dataIndex: 'default',
						width: 45,
						menuDisabled: true
    });

				this.deleteRow = function(grid, rowIndex, colIndex) {
						var s = grid.getStore();
						Ext.Msg.show({
								title: ~'Видалення'~,
								msg: ~'Видалити рядок?'~,
								iconCls: false,
								icon: Ext.MessageBox.WARNING,
								buttons: {yes: true, no: true},
								fn: function(btn) {
										if (btn == 'yes') {
												s.removeAt(rowIndex);
										}
								}
						})												
				}
    
				this.gridVO = new Ext.grid.EditorGridPanel({
						store: this.interface.storeVO,
						stripeRows: true,									
						viewConfig: {
							 forceFit: true
						},
						height: 300,
						colModel: new Ext.grid.ColumnModel({
								defaults: {
										sortable: true,
										editor: new Ext.form.TextField({
												allowBlank: false
										})		
								},
								columns: [this.colDefault, {
								  header: ~'Ім\'я'~,
										dataIndex: 'name'
								},{
									 header: ~'Аліас'~,
										dataIndex: 'alias'
								},{
									 header: ~'Адреса сервера'~,
									 dataIndex: 'server'
								},{
									 header: ~'Порт'~,
										dataIndex: 'port'
								},{
									 header: ~'DN'~,
										dataIndex: 'dn'
								},{
									 xtype: 'actioncolumn',
										iconCls: 'x-action-delete',
										width: 25,
										editor: null,
										menuDisabled: true,
										handler: this.deleteRow
								}]
      }),
						sm: new Ext.grid.RowSelectionModel({singleSelect:true})
    });
				
				this.formVO = new Ext.form.FormPanel({
						title: ~'Віртуальні організації'~,
						items: [this.gridVO],
						baseParams: {
							 cmd: 'save_settings_vo'
						},
						buttons: [{
						  text: ~'Додати'~,
								handler: function(){
								  var vo = self.interface.storeVO.recordType, 
										r = new vo({
												'default': false, 
												name: 'new vo',
												alias: '',
												server: '',
												port: '',
												dn: ''
										});
										self.gridVO.stopEditing();
										self.interface.storeVO.insert(0, r);
										self.gridVO.startEditing(0, 0);
								}
						},{
						  text: ~'Зберегти'~,
								handler: function(){
									 var store = self.gridVO.getStore(), s = '', i, d, default_vo = '';
										for (i = 0; i < store.getCount(); i++) {
										  d = store.getAt(i).data;
												s += '"' + d.alias + '" "' + d.server + '" "' + d.port + '" "' + d.dn + '" "' + d.name + '"\n';
												if (d['default'])
														default_vo = d.alias;
										}
										self.formVO.getForm().submit({
									   params: {
													 default_vo_alias: default_vo,
														vo_list: s
												},
												success: function(form, action){
													 var o = action.result || {};
														self.loadVO(o.grid_vo_install, default_vo);
												}
										})
								}
						}]
			 })
								
				this.gridRC = new Ext.grid.EditorGridPanel({
						store: new Ext.data.JsonStore({
					   idProperty: 'id',
								fields: ['id', 'remote_login', 'host', 'resource_manager', 'queues']
						}),
						stripeRows: true,									
						viewConfig: {
							 forceFit: true
						},
						height: 300,
						colModel: new Ext.grid.ColumnModel({
								defaults: {
										sortable: true,
										editor: new Ext.form.TextField({
												allowBlank: false
										})		
								},
								columns: [{
									 header: ~'Адреса сервера'~,
									 dataIndex: 'host'
								},{
									 header: ~'Користувач'~,
										dataIndex: 'remote_login'
								},{
									 header: ~'Менеджер ресурсів'~,
										dataIndex: 'resource_manager'
								},{
									 header: ~'Доступні черги'~,
										dataIndex: 'queues',
										editor: new Ext.form.TextField()
								},{
									 xtype: 'actioncolumn',
										iconCls: 'x-action-delete',
										width: 25,
										editor: null,
										menuDisabled: true,
										handler: this.deleteRow
								}]
      }),
						sm: new Ext.grid.RowSelectionModel({singleSelect:true})						
				});
				
				this.formRC = new Ext.form.FormPanel({
			   title: ~'Віддалені кластери'~,
						baseParams: {
							 cmd: 'save_settings_rc'
						},
			   items: [this.gridRC],
						buttons: [{
						  text: ~'Додати'~,
								handler: function(){
								  var store = self.gridRC.getStore(), n = 0, r, i;
										for (i = 0; i < store.getCount(); i++)
										  n = Math.max(n, parseInt(store.getAt(i).data['id']));
										n++;																																															
										r = new store.recordType({
												id: n,
												remote_login: '',
												host: '',
												resource_manager: ''
										});
										self.gridRC.stopEditing();
										store.insert(0, r);
										self.gridVO.startEditing(0, 0);
								}
						},{
						  text: ~'Зберегти'~,
								handler: function(){
									 var store = self.gridRC.getStore(), data = [], r, d, i, n = store.getCount();
										for (i = 0; i < n; i++) {
												r = store.getAt(i);
												d = r.data;
												d.phantom = r.phantom ? 1 : 0;
												data.push(d);
										}
										self.formRC.getForm().submit({
										  params: {
													 data: Ext.encode(data)
												},
												success: function(form, action){
													 var ids = action.result || {}, i, r, id, p;
														for (i = 0; i < store.getCount(); i++) {
																r = store.getAt(i);
																if (r.phantom) {
																		r.phantom = false;
																		id = r.data['id'];
																		if (ids[id] > 0 && ids[id] != id) 
																				r.data['id'] = ids[id];
																}																		
																r.commit();
														}														  
												}
										})
								}
						}]
				});				

				this.treeSections = new Ext.tree.TreePanel({
				  region: 'west',
						split: true,
						width: 200,
						rootVisible: false,
						lines: false,
						root: new Ext.tree.AsyncTreeNode({
						  expanded: true,
								children: [{									 
										leaf: true,
										iconCls: 'x-set-interface',
										panel: this.formInterfaceSettings
								},{
									 text: ~'Грід'~,
										iconCls: 'x-set-grid',
										expanded: true,
									 children: [{
												leaf: true,
												iconCls: 'x-set-grid-cert',
												panel: this.formCert
										},{
												leaf: true,
												iconCls: 'x-set-grid-auth',
												panel: this.formGridAuth
										},{
												leaf: true,
												iconCls: 'x-set-grid-vo',
												panel: this.formVO
										}]
								},{
										leaf: true,
										iconCls: 'x-set-remote',
										panel: this.formRC
								}]
						}),
						listeners: {
							 click: function(node, e) {
										if (node.isLeaf() && node.attributes.panel) {
											 for (var i = 0; i < self.forms.length; i++)
												  self.forms[i].setVisible(self.forms[i] == node.attributes.panel)
											 node.attributes.panel.setTitle(node.attributes.text);	
										}
								},
								afterrender: function(){
										this.root.cascade(function(){
												if (this.attributes.panel)
						        this.setText(this.attributes.panel.title);
												return true;
										});
										this.root.firstChild.select();
										self.forms[0].show()
								}
						}						
    })
				
				this.forms = [//this.formPersonalSettings, 
																		this.formInterfaceSettings, this.formCert, this.formGridAuth, this.formVO, this.formRC];
				
				var config = {
				  layout: 'border',
						items: [this.treeSections, {
								xtype: 'container',
								region: 'center',
								defaults: {
									 hidden: true,
										frame: true,
										labelWidth: 200
								},
								items: this.forms
						}]	
				}
				
		  Ext.applyIf(this, config);

    app.SettingsPanel.superclass.initComponent.call(this);
				
		}
});